
c-------------------------------------------------------------------

c$$$      subroutine def3(tb,mst2,delmst,stt,mw, mz, mt,
c$$$     $                xmsusytl,xmsusytr,xmsusybl,xmsusybr,xmtlr)
c$$$
c$$$      double precision mst2,delmst,stt,ctt
c$$$      double precision xmsusytl,xmsusytr,xmsusybl,xmsusybr,xmtlr,
c$$$     $                 xmsusytl2, xmsusytr2
c$$$      double precision mw,mz,mt,tb,b,c2b,sw2,dt1,dt2
c$$$      double precision rot(1:2,1:2), rottrans(1:2,1:2), 
c$$$     $                 mdiag(1:2,1:2), mnondiag(1:2,1:2), z(1:2,1:2)
c$$$
c$$$c$$$      write(*,*) 'Parameters in def3:'
c$$$c$$$      write(*,*) tb, mst2, stt, delmst, mw, mz, mt
c$$$
c$$$      b = datan(tb)
c$$$      c2b = dcos(2d0*b)
c$$$      sw2 = 1d0 - mw**2/mz**2
c$$$      dt1 = mz**2 * c2b * (.5d0 - 2d0/3d0 * sw2)
c$$$      dt2 = mz**2 * c2b * (       2d0/3d0 * sw2)
c$$$
c$$$      mdiag(1,1) = (mst2 - delmst)**2
c$$$      mdiag(1,2) = 0d0
c$$$      mdiag(2,1) = 0d0
c$$$      mdiag(2,2) = mst2**2
c$$$      ctt = dsqrt(1d0 - stt**2)
c$$$      rot(1,1) = ctt
c$$$      rot(1,2) = stt
c$$$      rot(2,1) = -stt
c$$$      rot(2,2) = ctt
c$$$      rottrans(1,1) = ctt
c$$$      rottrans(1,2) = -stt
c$$$      rottrans(2,1) = stt
c$$$      rottrans(2,2) = ctt
c$$$
c$$$      call matmult(rottrans, mdiag, z)
c$$$      call matmult(z, rot, mnondiag)
c$$$
c$$$      xmsusytl2 = mnondiag(1,1) - mt**2 - dt1
c$$$      xmsusytr2 = mnondiag(2,2) - mt**2 - dt2
c$$$      if ((xmsusytl2.ge.0d0).and.(xmsusytr2.ge.0d0)) then
c$$$         xmsusytl = dsqrt(mnondiag(1,1) - mt**2 - dt1)
c$$$         xmsusytr = dsqrt(mnondiag(2,2) - mt**2 - dt2)
c$$$         xmsusybl = xmsusytl
c$$$         xmsusybr = xmsusybl
c$$$         xmtlr = mnondiag(1,2)/mt
c$$$      else
c$$$         xmsusytl = 0d0
c$$$         xmsusytr = 0d0
c$$$         xmsusybl = 0d0
c$$$         xmsusybr = 0d0
c$$$         xmtlr = 0d0
c$$$      endif
c$$$
c$$$c      write(*,*) 'parameters from def3:'
c$$$c      write(*,*) xmsusytl, xmsusytr, xmsusybl, xmtlr
c$$$
c$$$      end


c-------------------------------------------------------------------

      subroutine matmult(a, b, c)

      double precision a(1:2,1:2), b(1:2,1:2), c(1:2,1:2)

      c(1,1) = a(1,1)*b(1,1) + a(1,2)*b(2,1)
      c(1,2) = a(1,1)*b(1,2) + a(1,2)*b(2,2)
      c(2,1) = a(2,1)*b(1,1) + a(2,2)*b(2,1)
      c(2,2) = a(2,1)*b(1,2) + a(2,2)*b(2,2)

      end
