

c------------------------------------------------------------------------
c------------------------------------------------------------------------

      subroutine def2

      double precision mw, mz, sw2, mt, mtrun, mb, as, alphasmz, gs, 
     $                 el, gf
      double precision cf, eps, pi
      complex*16 i
      double precision  MSt1, MSt2, stt, ctt, delmst,
     $                  MSb1, MSb2, stb, ctb,
     $                  msusy, msusytl, msusytr, msusybl, msusybr,
     $                  mtlr, mblr, au, ad, 
     $                  mmm, mgl, mue, 
     $                  beta, alpha, tb, ma

      common /smpara/ mw, mz, sw2, mt, mtrun, mb, as, alphasmz, gs, 
     $                el, gf
      common /para/ cf, eps, pi, i
      common /susypara/ MSt1, MSt2, stt, ctt, delmst,
     $                  MSb1, MSb2, stb, ctb,
     $                  msusy, msusytl, msusytr, msusybl, msusybr,
     $                  mtlr, mblr, au, ad, 
     $                  mmm, mgl, mue, 
     $                  beta, alpha, tb, ma

      double precision ml2t, mr2t, ml2b, mr2b, sgnt, sgnb, tt, bb
     $               , m12, m22, b, c2b

      b = datan(tb)
      c2b = dcos(2d0 * b)

c      write(*,*) 'def2:'
c      write(*,*) msusytl, msusytr, msusybl, msusybr, mz, sw2, mt,mb,c2b
      ml2t = msusytl**2 + mz**2*c2b*( .5d0 - 2d0/3d0*sw2) + mt**2
      mr2t = msusytr**2 + mz**2*c2b*(        2d0/3d0*sw2) + mt**2
      ml2b = msusybl**2 + mz**2*c2b*(-.5d0 + 1d0/3d0*sw2) + mb**2
      mr2b = msusybr**2 + mz**2*c2b*(      - 1d0/3d0*sw2) + mb**2
c      write(*,*) 'diagonal entries:'
c      write(*,*) ml2t, mr2t
      sgnt = (ml2t - mr2t)/dabs(ml2t - mr2t)
      sgnb = (ml2b - mr2b)/dabs(ml2b - mr2b)

      tt = datan(-sgnt*2d0*mt*mtlr/
     $           (-sgnt*(ml2t - mr2t) 
     $            -dsqrt((ml2t - mr2t)**2 + 4d0 * mt**2 * mtlr**2)))

      stt = dsin(tt)
      ctt = dcos(tt)

      bb = datan(-sgnb*2d0*mb*mblr/
     $           (-sgnb*(ml2b - mr2b) 
     $            -dsqrt((ml2b - mr2b)**2 + 4d0 * mb**2 * mblr**2)))

      stb = dsin(bb)
      ctb = dcos(bb)

      m12 = .5d0*(ml2t + mr2t 
     $            + sgnt * dsqrt((ml2t - mr2t)**2 + 4d0*mt**2*mtlr**2))
      m22 = .5d0*(ml2t + mr2t 
     $            - sgnt * dsqrt((ml2t - mr2t)**2 + 4d0*mt**2*mtlr**2))

      
      if ((m12.lt.0d0) .or. (m22.lt.0d0))  then
         MSt1 = 0d0
         MSt2 = 0d0
         goto 100
      endif
      MSt1 = dsqrt(m12)
      MSt2 = dsqrt(m22)

 100  continue

      m12 = .5d0*(ml2b + mr2b 
     $            + sgnb * dsqrt((ml2b - mr2b)**2 + 4d0*mb**2*mblr**2))
      m22 = .5d0*(ml2b + mr2b 
     $            - sgnb * dsqrt((ml2b - mr2b)**2 + 4d0*mb**2*mblr**2))

      
      if ((m12.lt.0d0) .or. (m22.lt.0d0))  then
         MSb1 = 0d0
         MSb2 = 0d0
         goto 200
      endif
      MSb1 = dsqrt(m12)
      MSb2 = dsqrt(m22)

 200  continue

c$$$      write(*,*) "Msusy    :",msusy
c$$$      write(*,*) "Mlr      :",mlr
c$$$      write(*,*) "MT       :", MT
c$$$      write(*,*) "theta_top:",tt
c$$$      write(*,*) "-Pi/4    :",-Pi/4d0
c$$$      write(*,*) real(msusytl), real(msusytr), 
c$$$     $           real(msusybl), real(msusybr)
c$$$      write(*,*) real(mtlr), real(mblr)
c$$$      write(*,*) 'Squark masses:'
c$$$      write(*,*) real(MSt1), real(MSt2), real(stt)
c$$$      write(*,*) real(MSb1), real(MSb2), real(stb)


      end
